import info.gridworld.world.*;
import info.gridworld.grid.*;
public class DiceGame extends World<Dice>
{
    private Grid gr;
    public DiceGame(){
        gr=new BoundedGrid(1,6);
        this.setGrid(gr);
        System.setProperty("info.gridworld.gui.selection", "hide");
    	System.setProperty("info.gridworld.gui.frametitle", "Tile Game");
    	System.setProperty("info.gridworld.gui.tooltips", "hide");
    	setMessage("Click Step to Roll\nClick Dice to hold");
    	for (int i=0; i<6; i++)
    	   add(new Location(0,i),getDice(toss()));
    	
    }
    public boolean locationClicked(Location loc){
       
        Dice d=(Dice)gr.get(loc);
        d.select();
        return true; //consume the mouse click
    }
    public Dice getDice(int value){
        if (value==1) return new Dice1();
        if (value==2) return new Dice2();
        if (value==3) return new Dice3();
        if (value==4) return new Dice4();
        if (value==5) return new Dice5();
        if (value==6) return new Dice6();
        return null;
    }
    public int toss(){
        return (int)(5*Math.random())+1;
    }
    
    public void step(){
        boolean noNewDice=true;
        for (int i=0; i<6; i++){
            Location loc = new Location(0,i);
            Dice d=(Dice)gr.get(loc);
            if (d.isHeld() ){
                d.lock();
            } else {
                remove(loc);
                add(loc,getDice(toss()));
                noNewDice=false;
            }
        }
        if (noNewDice)
            for (int i = 0 ; i< 6; i++){
               Location loc = new Location(0,i);
               remove(loc);
                add(loc,getDice(toss()));
            }
    }
}